unit uWinHelper;

{$mode objfpc}{$H+}

interface

uses
  uWinIpHlpApi, Sockets, SysUtils;

type
  TIPSegments = array[1..4] of Byte;


// Helper
function SockAddr4ToStr(const Addr: TSOCKET_ADDRESS): String;

implementation

{ Converts IPv4 SOCKET_ADDRESS to String }
function SockAddr4ToStr(const Addr: TSOCKET_ADDRESS): String;
var
  i: Integer;
  s: String;
begin
  if (Addr.lpSockaddr = nil) or (Addr.iSockAddrLength <= 0) then
  begin
    Result := '';
    Exit;
  end;

  s := '';
  for i := 1 to High(Addr.lpSockaddr^.sin_addr.s_bytes) do begin
    if (i = (High(Addr.lpSockaddr^.sin_addr.s_bytes))) then
      s := s + Format('%d', [Addr.lpSockaddr^.sin_addr.s_bytes[i]])
    else
      s := s + Format('%d.', [Addr.lpSockaddr^.sin_addr.s_bytes[i]]);
  end;
  Result := s;
end;


end.

